/* view.c generated by valac 0.56.13, the Vala compiler
 * generated from view.vala, do not modify */

/* view.vala
 *
 * Copyright (C) 2017 Red Hat, Inc.
 * Copyright (C) 2023 Markus Göllnitz
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Petr Štětka <pstetka@redhat.com>
 *          Markus Göllnitz <camelcasenick@bewares.it>
 */

#include <adwaita.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define USAGE_TYPE_VIEW (usage_view_get_type ())
#define USAGE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), USAGE_TYPE_VIEW, UsageView))
#define USAGE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), USAGE_TYPE_VIEW, UsageViewClass))
#define USAGE_IS_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), USAGE_TYPE_VIEW))
#define USAGE_IS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), USAGE_TYPE_VIEW))
#define USAGE_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), USAGE_TYPE_VIEW, UsageViewClass))

typedef struct _UsageView UsageView;
typedef struct _UsageViewClass UsageViewClass;
typedef struct _UsageViewPrivate UsageViewPrivate;
enum  {
	USAGE_VIEW_0_PROPERTY,
	USAGE_VIEW_NUM_PROPERTIES
};
static GParamSpec* usage_view_properties[USAGE_VIEW_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

#define USAGE_TYPE_SUB_VIEW (usage_sub_view_get_type ())
#define USAGE_SUB_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), USAGE_TYPE_SUB_VIEW, UsageSubView))
#define USAGE_SUB_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), USAGE_TYPE_SUB_VIEW, UsageSubViewClass))
#define USAGE_IS_SUB_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), USAGE_TYPE_SUB_VIEW))
#define USAGE_IS_SUB_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), USAGE_TYPE_SUB_VIEW))
#define USAGE_SUB_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), USAGE_TYPE_SUB_VIEW, UsageSubViewClass))

typedef struct _UsageSubView UsageSubView;
typedef struct _UsageSubViewClass UsageSubViewClass;
typedef struct _UsageSubViewPrivate UsageSubViewPrivate;
enum  {
	USAGE_SUB_VIEW_0_PROPERTY,
	USAGE_SUB_VIEW_NUM_PROPERTIES
};
static GParamSpec* usage_sub_view_properties[USAGE_SUB_VIEW_NUM_PROPERTIES];

struct _UsageView {
	AdwBreakpointBin parent_instance;
	UsageViewPrivate * priv;
	gchar* title;
	gchar* icon_name;
};

struct _UsageViewClass {
	AdwBreakpointBinClass parent_class;
};

struct _UsageSubView {
	AdwBin parent_instance;
	UsageSubViewPrivate * priv;
	gchar* title;
};

struct _UsageSubViewClass {
	AdwBinClass parent_class;
	void (*search_in_processes) (UsageSubView* self, const gchar* text);
};

static gpointer usage_view_parent_class = NULL;
static gpointer usage_sub_view_parent_class = NULL;

VALA_EXTERN GType usage_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (UsageView, g_object_unref)
VALA_EXTERN UsageView* usage_view_construct (GType object_type);
static GObject * usage_view_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties);
static void usage_view_finalize (GObject * obj);
static GType usage_view_get_type_once (void);
VALA_EXTERN GType usage_sub_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (UsageSubView, g_object_unref)
VALA_EXTERN void usage_sub_view_search_in_processes (UsageSubView* self,
                                         const gchar* text);
VALA_EXTERN UsageSubView* usage_sub_view_construct (GType object_type);
static void usage_sub_view_real_search_in_processes (UsageSubView* self,
                                              const gchar* text);
static void usage_sub_view_finalize (GObject * obj);
static GType usage_sub_view_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

UsageView*
usage_view_construct (GType object_type)
{
	UsageView * self = NULL;
#line 32 "../src/view.vala"
	self = (UsageView*) g_object_new (object_type, NULL);
#line 32 "../src/view.vala"
	return self;
#line 130 "view.c"
}

static GObject *
usage_view_constructor (GType type,
                        guint n_construct_properties,
                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	UsageView * self;
#line 27 "../src/view.vala"
	parent_class = G_OBJECT_CLASS (usage_view_parent_class);
#line 27 "../src/view.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 27 "../src/view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, USAGE_TYPE_VIEW, UsageView);
#line 28 "../src/view.vala"
	g_object_set ((GtkWidget*) self, "width-request", 360, NULL);
#line 29 "../src/view.vala"
	g_object_set ((GtkWidget*) self, "height-request", 300, NULL);
#line 27 "../src/view.vala"
	return obj;
#line 153 "view.c"
}

static void
usage_view_class_init (UsageViewClass * klass,
                       gpointer klass_data)
{
#line 23 "../src/view.vala"
	usage_view_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/view.vala"
	G_OBJECT_CLASS (klass)->constructor = usage_view_constructor;
#line 23 "../src/view.vala"
	G_OBJECT_CLASS (klass)->finalize = usage_view_finalize;
#line 166 "view.c"
}

static void
usage_view_instance_init (UsageView * self,
                          gpointer klass)
{
}

static void
usage_view_finalize (GObject * obj)
{
	UsageView * self;
#line 23 "../src/view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, USAGE_TYPE_VIEW, UsageView);
#line 24 "../src/view.vala"
	_g_free0 (self->title);
#line 25 "../src/view.vala"
	_g_free0 (self->icon_name);
#line 23 "../src/view.vala"
	G_OBJECT_CLASS (usage_view_parent_class)->finalize (obj);
#line 187 "view.c"
}

static GType
usage_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (UsageViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) usage_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UsageView), 0, (GInstanceInitFunc) usage_view_instance_init, NULL };
	GType usage_view_type_id;
	usage_view_type_id = g_type_register_static (adw_breakpoint_bin_get_type (), "UsageView", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	return usage_view_type_id;
}

GType
usage_view_get_type (void)
{
	static volatile gsize usage_view_type_id__once = 0;
	if (g_once_init_enter (&usage_view_type_id__once)) {
		GType usage_view_type_id;
		usage_view_type_id = usage_view_get_type_once ();
		g_once_init_leave (&usage_view_type_id__once, usage_view_type_id);
	}
	return usage_view_type_id__once;
}

UsageSubView*
usage_sub_view_construct (GType object_type)
{
	UsageSubView * self = NULL;
#line 39 "../src/view.vala"
	self = (UsageSubView*) g_object_new (object_type, NULL);
#line 39 "../src/view.vala"
	return self;
#line 219 "view.c"
}

static void
usage_sub_view_real_search_in_processes (UsageSubView* self,
                                         const gchar* text)
{
#line 42 "../src/view.vala"
	g_critical ("Type `%s' does not implement abstract method `usage_sub_view_search_in_processes'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 42 "../src/view.vala"
	return;
#line 230 "view.c"
}

void
usage_sub_view_search_in_processes (UsageSubView* self,
                                    const gchar* text)
{
	UsageSubViewClass* _klass_;
#line 42 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 42 "../src/view.vala"
	_klass_ = USAGE_SUB_VIEW_GET_CLASS (self);
#line 42 "../src/view.vala"
	if (_klass_->search_in_processes) {
#line 42 "../src/view.vala"
		_klass_->search_in_processes (self, text);
#line 246 "view.c"
	}
}

static void
usage_sub_view_class_init (UsageSubViewClass * klass,
                           gpointer klass_data)
{
#line 36 "../src/view.vala"
	usage_sub_view_parent_class = g_type_class_peek_parent (klass);
#line 36 "../src/view.vala"
	((UsageSubViewClass *) klass)->search_in_processes = (void (*) (UsageSubView*, const gchar*)) usage_sub_view_real_search_in_processes;
#line 36 "../src/view.vala"
	G_OBJECT_CLASS (klass)->finalize = usage_sub_view_finalize;
#line 260 "view.c"
}

static void
usage_sub_view_instance_init (UsageSubView * self,
                              gpointer klass)
{
}

static void
usage_sub_view_finalize (GObject * obj)
{
	UsageSubView * self;
#line 36 "../src/view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, USAGE_TYPE_SUB_VIEW, UsageSubView);
#line 37 "../src/view.vala"
	_g_free0 (self->title);
#line 36 "../src/view.vala"
	G_OBJECT_CLASS (usage_sub_view_parent_class)->finalize (obj);
#line 279 "view.c"
}

static GType
usage_sub_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (UsageSubViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) usage_sub_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UsageSubView), 0, (GInstanceInitFunc) usage_sub_view_instance_init, NULL };
	GType usage_sub_view_type_id;
	usage_sub_view_type_id = g_type_register_static (adw_bin_get_type (), "UsageSubView", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	return usage_sub_view_type_id;
}

GType
usage_sub_view_get_type (void)
{
	static volatile gsize usage_sub_view_type_id__once = 0;
	if (g_once_init_enter (&usage_sub_view_type_id__once)) {
		GType usage_sub_view_type_id;
		usage_sub_view_type_id = usage_sub_view_get_type_once ();
		g_once_init_leave (&usage_sub_view_type_id__once, usage_sub_view_type_id);
	}
	return usage_sub_view_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

